/////////////////////////////////////////////////////////////////////////////
// GbError.h : Gamebios Error
/////////////////////////////////////////////////////////////////////////////
#ifndef __GBERROR_H__
#define __GBERROR_H__
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "Gamebios.h"

/////////////////////////////////////////////////////////////////////////////
// Prototype

#define GBERROR_MAXLENGTH							(128)

#define GBERROR_GBMASK								(0xf000)
#define GBERROR_NOMASK								(0x0fff)

#define GBERROR_ALREADYSTARTUPPED					(0x0001)
#define GBERROR_NOTSTARTUPPED						(0x0002)
#define GBERROR_FAILEDTOSTARTUP						(0x0003)
#define GBERROR_DEVICEALREADYSTARTUPPED				(0x0004)
#define GBERROR_DEVICENOTSTARTUPPED					(0x0005)
#define GBERROR_FAILEDTOSTARTUPDEVICE				(0x0006)
#define GBERROR_UNKNOWNERROR						(0x0007)
#define GBERROR_INVALIDVALUE						(0x0008)

#define GBERROR_GB									(0x0000)
#define GBERROR_GB_ALREADYSTARTUPPED				(GBERROR_GB | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GB_NOTSTARTUPPED					(GBERROR_GB | GBERROR_NOTSTARTUPPED)
#define GBERROR_GB_FAILEDTOSTARTUP					(GBERROR_GB | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GB_UNKNOWNERROR						(GBERROR_GB | GBERROR_UNKNOWNERROR)
#define GBERROR_GB_INVALIDVALUE						(GBERROR_GB | GBERROR_INVALIDVALUE)

#define GBERROR_GBVIDEO								(0x1000)
#define GBERROR_GBVIDEO_ALREADYSTARTUPPED			(GBERROR_GBVIDEO | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBVIDEO_NOTSTARTUPPED				(GBERROR_GBVIDEO | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBVIDEO_FAILEDTOSTARTUP				(GBERROR_GBVIDEO | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBVIDEO_DEVICEALREADYSTARTUPPED		(GBERROR_GBVIDEO | GBERROR_DEVICEALREADYSTARTUPPED)
#define GBERROR_GBVIDEO_DEVICENOTSTARTUPPED			(GBERROR_GBVIDEO | GBERROR_DEVICENOTSTARTUPPED)
#define GBERROR_GBVIDEO_FAILEDTOSTARTUPDEVICE		(GBERROR_GBVIDEO | GBERROR_FAILEDTOSTARTUPDEVICE)
#define GBERROR_GBVIDEO_UNKNOWNERROR				(GBERROR_GBVIDEO | GBERROR_UNKNOWNERROR)
#define GBERROR_GBVIDEO_INVALIDVALUE				(GBERROR_GBVIDEO | GBERROR_INVALIDVALUE)
#define GBERROR_GBVIDEO_COULDNOTFOUNDDEVICE			(GBERROR_GBVIDEO | 0x0100)
#define GBERROR_GBVIDEO_FAILEDTOSETVIDEOMODE		(GBERROR_GBVIDEO | 0x0101)
#define GBERROR_GBVIDEO_DIRECTDRAWOLDEST			(GBERROR_GBVIDEO | 0x0102)

#define GBERROR_GB2D								(0x2000)
#define GBERROR_GB2D_ALREADYSTARTUPPED				(GBERROR_GB2D | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GB2D_NOTSTARTUPPED					(GBERROR_GB2D | GBERROR_NOTSTARTUPPED)
#define GBERROR_GB2D_FAILEDTOSTARTUP				(GBERROR_GB2D | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GB2D_UNKNOWNERROR					(GBERROR_GB2D | GBERROR_UNKNOWNERROR)
#define GBERROR_GB2D_INVALIDVALUE					(GBERROR_GB2D | GBERROR_INVALIDVALUE)
#define GBERROR_GB2D_FAILEDTOCREATEBUFFER			(GBERROR_GB2D | 0x0100)

#define GBERROR_GB3D								(0x3000)
#define GBERROR_GB3D_ALREADYSTARTUPPED				(GBERROR_GB3D | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GB3D_NOTSTARTUPPED					(GBERROR_GB3D | GBERROR_NOTSTARTUPPED)
#define GBERROR_GB3D_FAILEDTOSTARTUP				(GBERROR_GB3D | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GB3D_DEVICEALREADYSTARTUPPED		(GBERROR_GB3D | GBERROR_DEVICEALREADYSTARTUPPED)
#define GBERROR_GB3D_DEVICENOTSTARTUPPED			(GBERROR_GB3D | GBERROR_DEVICENOTSTARTUPPED)
#define GBERROR_GB3D_FAILEDTOSTARTUPDEVICE			(GBERROR_GB3D | GBERROR_FAILEDTOSTARTUPDEVICE)
#define GBERROR_GB3D_UNKNOWNERROR					(GBERROR_GB3D | GBERROR_UNKNOWNERROR)
#define GBERROR_GB3D_INVALIDVALUE					(GBERROR_GB3D | GBERROR_INVALIDVALUE)
#define GBERROR_GB3D_FAILEDTOCREATETEXTURE			(GBERROR_GB3D | 0x0100)
#define GBERROR_GB3D_FAILEDTOSETVIEWPORT			(GBERROR_GB3D | 0x0101)
#define GBERROR_GB3D_FAILEDTOCREATEMODEL			(GBERROR_GB3D | 0x0102)
#define GBERROR_GB3D_FAILEDTOCREATEMATERIAL			(GBERROR_GB3D | 0x0103)
#define GBERROR_GB3D_FAILEDTOCREATELIGHT			(GBERROR_GB3D | 0x0104)
#define GBERROR_GB3D_FAILEDTOCREATEVIEWPORT			(GBERROR_GB3D | 0x0105)

#define GBERROR_GBSOUND								(0x4000)
#define GBERROR_GBSOUND_ALREADYSTARTUPPED			(GBERROR_GBSOUND | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBSOUND_NOTSTARTUPPED				(GBERROR_GBSOUND | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBSOUND_FAILEDTOSTARTUP				(GBERROR_GBSOUND | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBSOUND_DEVICEALREADYSTARTUPPED		(GBERROR_GBSOUND | GBERROR_DEVICEALREADYSTARTUPPED)
#define GBERROR_GBSOUND_DEVICENOTSTARTUPPED			(GBERROR_GBSOUND | GBERROR_DEVICENOTSTARTUPPED)
#define GBERROR_GBSOUND_FAILEDTOSTARTUPDEVICE		(GBERROR_GBSOUND | GBERROR_FAILEDTOSTARTUPDEVICE)
#define GBERROR_GBSOUND_UNKNOWNERROR				(GBERROR_GBSOUND | GBERROR_UNKNOWNERROR)
#define GBERROR_GBSOUND_INVALIDVALUE				(GBERROR_GBSOUND | GBERROR_INVALIDVALUE)
#define GBERROR_GBSOUND_FAILEDTOCREATEBUFFER		(GBERROR_GBSOUND | 0x0100)

#define GBERROR_GBMEDIA								(0x5000)
#define GBERROR_GBMEDIA_ALREADYSTARTUPPED			(GBERROR_GBMEDIA | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBMEDIA_NOTSTARTUPPED				(GBERROR_GBMEDIA | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBMEDIA_FAILEDTOSTARTUP				(GBERROR_GBMEDIA | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBMEDIA_UNKNOWNERROR				(GBERROR_GBMEDIA | GBERROR_UNKNOWNERROR)
#define GBERROR_GBMEDIA_INVALIDVALUE				(GBERROR_GBMEDIA | GBERROR_INVALIDVALUE)
#define GBERROR_GBMEDIA_FAILEDTOCREATEBUFFER		(GBERROR_GBMEDIA | 0x0100)
#define GBERROR_GBMEDIA_FAILEDTOPLAY				(GBERROR_GBMEDIA | 0x0101)
#define GBERROR_GBMEDIA_FAILEDTOSTOP				(GBERROR_GBMEDIA | 0x0102)
#define GBERROR_GBMEDIA_FAILEDTOPAUSE				(GBERROR_GBMEDIA | 0x0103)

#define GBERROR_GBMUSIC								(0x6000)
#define GBERROR_GBMUSIC_ALREADYSTARTUPPED			(GBERROR_GBMUSIC | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBMUSIC_NOTSTARTUPPED				(GBERROR_GBMUSIC | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBMUSIC_FAILEDTOSTARTUP				(GBERROR_GBMUSIC | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBMUSIC_UNKNOWNERROR				(GBERROR_GBMUSIC | GBERROR_UNKNOWNERROR)
#define GBERROR_GBMUSIC_INVALIDVALUE				(GBERROR_GBMUSIC | GBERROR_INVALIDVALUE)
#define GBERROR_GBMUSIC_FAILEDTOSETACTIVATELEVEL	(GBERROR_GBMUSIC | 0x0100)
#define GBERROR_GBMUSIC_FAILEDTOSTARTUPPORT			(GBERROR_GBMUSIC | 0x0101)
#define GBERROR_GBMUSIC_PORTALREADYSTARTUPPED		(GBERROR_GBMUSIC | 0x0102)
#define GBERROR_GBMUSIC_PORTNOTSTARTUPPED			(GBERROR_GBMUSIC | 0x0103)
#define GBERROR_GBMUSIC_FAILEDTOSTARTUPCDAUDIO		(GBERROR_GBMUSIC | 0x0104)
#define GBERROR_GBMUSIC_CDAUDIOALREADYSTARTUPPED	(GBERROR_GBMUSIC | 0x0105)
#define GBERROR_GBMUSIC_CDAUDIONOTSTARTUPPED		(GBERROR_GBMUSIC | 0x0106)
#define GBERROR_GBMUSIC_FAILEDTOCREATEBUFFER		(GBERROR_GBMUSIC | 0x0107)
#define GBERROR_GBMUSIC_FAILEDTOPLAY				(GBERROR_GBMUSIC | 0x0108)
#define GBERROR_GBMUSIC_FAILEDTOSTOP				(GBERROR_GBMUSIC | 0x0109)
#define GBERROR_GBMUSIC_FAILEDTOPAUSE				(GBERROR_GBMUSIC | 0x010a)
#define GBERROR_GBMUSIC_FAILEDTOGETTRACKCOUNT		(GBERROR_GBMUSIC | 0x010b)
#define GBERROR_GBMUSIC_FAILEDTOGETVOLUME			(GBERROR_GBMUSIC | 0x010c)
#define GBERROR_GBMUSIC_FAILEDTOSETVOLUME			(GBERROR_GBMUSIC | 0x010d)
#define GBERROR_GBMUSIC_FAILEDTOGETCURRENTPOSITION	(GBERROR_GBMUSIC | 0x010e)

#define GBERROR_GBINPUT								(0x7000)
#define GBERROR_GBINPUT_ALREADYSTARTUPPED			(GBERROR_GBINPUT | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBINPUT_NOTSTARTUPPED				(GBERROR_GBINPUT | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBINPUT_FAILEDTOSTARTUP				(GBERROR_GBINPUT | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBINPUT_UNKNOWNERROR				(GBERROR_GBINPUT | GBERROR_UNKNOWNERROR)
#define GBERROR_GBINPUT_INVALIDVALUE				(GBERROR_GBINPUT | GBERROR_INVALIDVALUE)
#define GBERROR_GBINPUT_DEVICEALREADYSTARTUPPED		(GBERROR_GBINPUT | GBERROR_DEVICEALREADYSTARTUPPED)
#define GBERROR_GBINPUT_DEVICENOTSTARTUPPED			(GBERROR_GBINPUT | GBERROR_DEVICENOTSTARTUPPED)
#define GBERROR_GBINPUT_FAILEDTOCREATEEFFECT		(GBERROR_GBINPUT | 0x0100)

#define GBERROR_GBNETWORK							(0x8000)
#define GBERROR_GBNETWORK_ALREADYSTARTUPPED			(GBERROR_GBNETWORK | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBNETWORK_NOTSTARTUPPED				(GBERROR_GBNETWORK | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBNETWORK_FAILEDTOSTARTUP			(GBERROR_GBNETWORK | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBNETWORK_UNKNOWNERROR				(GBERROR_GBNETWORK | GBERROR_UNKNOWNERROR)
#define GBERROR_GBNETWORK_INVALIDVALUE				(GBERROR_GBNETWORK | GBERROR_INVALIDVALUE)
#define GBERROR_GBNETWORK_FAILEDTOCREATESESSION		(GBERROR_GBNETWORK | 0x0100)
#define GBERROR_GBNETWORK_FAILEDTOSETSESSIONMODE	(GBERROR_GBNETWORK | 0x0101)
#define GBERROR_GBNETWORK_FAILEDTOJOINTOSESSION		(GBERROR_GBNETWORK | 0x0102)

#define GBERROR_GBLIST								(0x9000)
#define GBERROR_GBLIST_ALREADYSTARTUPPED			(GBERROR_GBLIST | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBLIST_NOTSTARTUPPED				(GBERROR_GBLIST | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBLIST_FAILEDTOSTARTUP				(GBERROR_GBLIST | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBLIST_UNKNOWNERROR					(GBERROR_GBLIST | GBERROR_UNKNOWNERROR)
#define GBERROR_GBLIST_INVALIDVALUE					(GBERROR_GBLIST | GBERROR_INVALIDVALUE)
#define GBERROR_GBLIST_FAILEDTOCREATELIST			(GBERROR_GBLIST | 0x0100)

#define GBERROR_GBDEBUG								(0xf000)
#define GBERROR_GBDEBUG_ALREADYSTARTUPPED			(GBERROR_GBDEBUG | GBERROR_ALREADYSTARTUPPED)
#define GBERROR_GBDEBUG_NOTSTARTUPPED				(GBERROR_GBDEBUG | GBERROR_NOTSTARTUPPED)
#define GBERROR_GBDEBUG_FAILEDTOSTARTUP				(GBERROR_GBDEBUG | GBERROR_FAILEDTOSTARTUP)
#define GBERROR_GBDEBUG_UNKNOWNERROR				(GBERROR_GBDEBUG | GBERROR_UNKNOWNERROR)
#define GBERROR_GBDEBUG_INVALIDVALUE				(GBERROR_GBDEBUG | GBERROR_INVALIDVALUE)

GBEXPORT VOID  GBErrorGetLastError(LPSTR pszError);
GBEXPORT DWORD GBErrorGetLastError();

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
